/*****************************************************************************

  Licensed to Accellera Systems Initiative Inc. (Accellera) under one or
  more contributor license agreements.  See the NOTICE file distributed
  with this work for additional information regarding copyright ownership.
  Accellera licenses this file to you under the Apache License, Version 2.0
  (the "License"); you may not use this file except in compliance with the
  License.  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
  implied.  See the License for the specific language governing
  permissions and limitations under the License.

 *****************************************************************************/
// throw error when TDF module instantiates a SystemC module

#include <systemc-ams>
#include "test_utilities.h"

SC_MODULE( nested )
{
  SC_CTOR( nested ) {}
};

SCA_TDF_MODULE( top )
{
  // not allowed to instantiate SystemC modules in TDF module - throw error
  nested nested1;

  void processing() {}

  void set_attributes()
  {
    set_timestep(1.0, sc_core::SC_MS);
  }

  SCA_CTOR( top ) : nested1("nested1") {}
};

int sc_main( int argn, char*[] )
{
  TEST_LABEL_START;

  if (argn == 1)
    sc_core::sc_report_handler::set_handler(test_util::report_handler);

  top top1("top1");

  sc_core::sc_start(2.0, sc_core::SC_MS);

  TEST_LABEL_END_WITHOUT_ERROR;

  return 0;
}
